config/routes.rb
Rails.application.routes.draw do
  resources :lottery_topics
  resources :posts
  resource :users,
    only: [:edit, :update, :delete],
    controller: 'devise/registrations',
    as: :user_registration do
    get 'cancel'
  end

  devise_for :users, skip: [:registrations]
  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html
  root "home#index"
  resources :users do
    resource :reset_passwords
  end
  resources :admins
  resources :admins,
    only: [:edit, :update, :delete],
    controller: 'devise/registrations',
    as: :admin_registration do
    get 'cancel'
  end
  resources :agents do 
    resources :member_invoices do
      resources :members do
        get '/confirmed', to: 'member_invoices#confirmed'
      end
    end
  end
  resources :members
  resources :profiles do
    resource :passwords
  end
  resources :lotteries
  resources :bills do
    resources :lotteries
    get '/confirmed', to: 'bills#confirmed'
  end

  resources :invoices

  get 'rood', to: 'lotteries#rood'
  get 'reverse', to: 'lotteries#reverse'
  get 'all_reverse', to: 'lotteries#all_reverse'
  get 'run', to: 'lotteries#run'
  get 'destroy_group', to: 'lotteries#destroy_group'

  get '/create_lottery', to: 'home#owner_lottery'
end

app/models/user.rb
class User < ApplicationRecord
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable, :trackable and :omniauthable
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :validatable

  has_one :user_datum
  has_many :lotteries
  has_many :bills
  has_many :invoices

  accepts_nested_attributes_for :user_datum

  attr_writer :login

  ROLES = ["agent", "member"]
  MEMBERROLES = ["member"]
  FIGHTABLE = [100, 90, 80, 70, 60, 50, 40, 30, 20, 10, 0]

  validates :name, presence: { message: "ไม่สามารถใส่เป็นค่าว่างได้" }
  validates_uniqueness_of :name, message: "ชื่อนี้ถูกใช้ไปแล้ว กรุณาลองชื่อใหม่" 
  validates :username, presence: { message: "ไม่สามารถใส่เป็นค่าว่างได้" }
  validates_uniqueness_of :username, message: "username นี้ถูกใช้ไปแล้ว กรุณาลอง username ใหม่"
  validates :email, presence: { message: "ไม่สามารถใส่เป็นค่าว่างได้" }

  def fightable

    self.user_datum.fightable = 0 if self.user_datum.fightable.nil?

    if self.user_datum.fightable == 100
      fightable = [100, 90, 80, 70, 60, 50, 40, 30, 20, 10, 0]
    elsif self.user_datum.fightable == 90
      fightable = [90, 80, 70, 60, 50, 40, 30, 20, 10, 0]
    elsif self.user_datum.fightable == 80
      fightable = [80, 70, 60, 50, 40, 30, 20, 10, 0]
    elsif self.user_datum.fightable == 70
      fightable = [70, 60, 50, 40, 30, 20, 10, 0]
    elsif self.user_datum.fightable == 60
      fightable = [60, 50, 40, 30, 20, 10, 0]
    elsif self.user_datum.fightable == 50
      fightable = [50, 40, 30, 20, 10, 0]
    elsif self.user_datum.fightable == 40
      fightable = [40, 30, 20, 10, 0]
    elsif self.user_datum.fightable == 30
      fightable = [30, 20, 10, 0]
    elsif self.user_datum.fightable == 20
      fightable = [20, 10, 0]
    elsif self.user_datum.fightable == 10
      fightable = [10, 0]
    elsif self.user_datum.fightable == 0
      fightable = [0]
    end
    fightable
  end

  def login
    @login || self.username || self.email
  end

  def super_admin?
    self.role == "super_admin"
  end

  def admin?
    self.role == "admin"
  end

  def agent?
    self.role == "agent"
  end

  def member?
    self.role == "member"
  end

  def avalability_member?
    self.super_admin? || self.admin? || self.agent?
  end

  def avalability_agent?
    self.super_admin? || self.admin?
  end

  def avalability_admin?
    self.super_admin?
  end

  def self.create_user_datum(user, params)
    UserDatum.create(
      user: user,
      percent: params[:member][:percent],
      user_percent: params[:member][:user_percent],
      three_percent: params[:member][:three_percent],
      three_reverse_percent: params[:member][:three_reverse_percent],
      run_percent: params[:member][:run_percent],
    )
  end
end

app/controllers/users_controller.rb
class UsersController < ApplicationController

  # before_action :set_user, except: [:index, :create, :new]
  before_action :authenticate_user_role!

  def index
    # @users = User.all
    @users = User.where(parent_id: current_user.id)
    @members = User.where(parent_id: current_user.id, role: 'member')
    @agents = User.where(parent_id: current_user.id, role: 'agent')
  end

  def show
    @user = User.where(parent_id: current_user.id).find(params[:id])
  end

  def new
    @user = User.new
    @user_datum = @user.build_user_datum
  end

  def edit
    @user = User.where(parent_id: current_user.id).find(params[:id])
    @user_datum = @user.user_datum
  end

  def update
    @user = User.where(parent_id: current_user.id).find(params[:id])
    respond_to do |format|
      if @user.update(user_params)
        # format.html { redirect_to user_url(@user), notice: "แก้ไขผู้ใช้งานเรียบร้อยแล้ว" } if current_user.id.to_s == params[:id]
        # if current_user.id.to_s != params[:id]
        #   if @user.agent?
        #     format.html { redirect_to agents_url, notice: "แก้ไขผู้ใช้งานเรียบร้อยแล้ว" }
        #   end
        #   format.html { redirect_to members_url, notice: "แก้ไขผู้ใช้งานเรียบร้อยแล้ว" }
        # end
        if params[:id].to_i == current_user.id
          format.html { redirect_to profile_url(@user), notice: "แก้ไขผู้ใช้งานเรียบร้อยแล้ว" }
        else
          format.html { redirect_to users_url, notice: "แก้ไขผู้ใช้งานเรียบร้อยแล้ว" }
        end
      else
        format.html { render :edit, status: :unprocessable_entity }
        format.json { render json: @user.errors, status: :unprocessable_entity }
      end
    end
  end

  def create
    @user = User.new(user_params)
    @user.parent_id = current_user.id

    respond_to do |format|
      if @user.save
        # User.create_user_datum(@user, params)
        format.html { redirect_to users_url, notice: "เพิ่ม User แล้ว" }
        format.json { render :show, status: :created, location: @user }
      else
        format.html { render :new, status: :unprocessable_entity }
        format.json { render json: @user.errors, status: :unprocessable_entity }
      end
    end
  end

  def destroy

    @user = User.where(parent_id: current_user.id).find(params[:id])

    @user.destroy

    respond_to do |format|
      format.html { redirect_to members_url, notice: "ลบ Member ชื่อ #{@user.name} แล้ว" }
      format.json { head :no_content }
    end
  end

  private
    def set_user
      @user = User.find(params[:id])
    end

    def user_params
      params.require(:user).permit(:name, 
        :role, 
        :email, 
        :username, 
        :password, 
        :password_confirmation,
        user_datum_attributes: [:credit, :percent, :three_percent, :three_reverse_percent, :run_percent, :run_user_percent, :three_user_percent, :run_bottom_percent, :user_percent, :id, :fightable ])
    end

    def authenticate_user_role!
      if current_user.member?
        redirect_to root_path
      end
    end
end

app/helpers/user_helper.rb
module UserHelper
end

app/views/users/_form.html.erb
<%= form_with model: user, local: true do |form| %>

  <div class="form-group">
    <%= form.label :ชื่อ, style: "display: block" %>
    <%= form.text_field :name, class: 'form-control' %>
    <% user.errors.full_messages_for(:name).each do |error_message| %>
      <div class="text-red">
        <%= error_message.sub("name","") %>
      </div>
    <% end %>

    <%= form.label :username, style: "display: block" %>
    <%= form.text_field :username, class: 'form-control' %>
    <% user.errors.full_messages_for(:username).each do |error_message| %>
      <div class="text-red">
        <%= error_message.sub("username","") %>
      </div>
    <% end %>

    <%= form.label :email, style: "display: block" %>
    <%= form.text_field :email, class: 'form-control' %>
    <% user.errors.full_messages_for(:email).each do |error_message| %>
      <div class="text-red">
        <%= error_message.sub("email","") %>
      </div>
    <% end %>

    <%= form.fields_for :user_datum do |datum| %>
    
      <%= datum.label 'สองตัว/บาทละ', style: "display: block" %>
      <%= datum.text_field :percent, class: 'form-control' %>
      <% user.errors.full_messages_for(:user_percent).each do |error_message| %>
        <div class="text-red">
          <%= error_message.sub("percent","") %>
        </div>
      <% end %>

      <%= datum.label 'สามตัวตรง/บาทละ', style: "display: block" %>
      <%= datum.text_field :three_percent, class: 'form-control' %>
      <% user.errors.full_messages_for(:three_percent).each do |error_message| %>
        <div class="text-red">
          <%= error_message.sub("three_percent","") %>
        </div>
      <% end %>

      <%= datum.label 'สามตัวโต๊ด/บาทละ', style: "display: block" %>
      <%= datum.text_field :three_reverse_percent, class: 'form-control' %>
      <% user.errors.full_messages_for(:three_reverse_percent).each do |error_message| %>
        <div class="text-red">
          <%= error_message.sub("three_reverse_percent","") %>
        </div>
      <% end %>

      <%= datum.label 'วิ่งบน/บาทละ', style: "display: block" %>
      <%= datum.text_field :run_percent, class: 'form-control' %>
      <% user.errors.full_messages_for(:run_percent).each do |error_message| %>
        <div class="text-red">
          <%= error_message.sub("run_percent","") %>
        </div>
      <% end %>

      <%= datum.label 'วิ่งล่าง/บาทละ', style: "display: block" %>
      <%= datum.text_field :run_bottom_percent, class: 'form-control' %>
      <% user.errors.full_messages_for(:run_percent).each do |error_message| %>
        <div class="text-red">
          <%= error_message.sub("run_percent","") %>
        </div>
      <% end %>

      <%= datum.label :เปอร์เซ็น, style: "display: block" %>
      <%= datum.text_field :user_percent, class: 'form-control' %>
      <% user.errors.full_messages_for(:percent_user).each do |error_message| %>
        <div class="text-red">
          <%= error_message.sub("percent","") %>
        </div>
      <% end %>

      <%= datum.label :'สามตัว/เปอร์เซ็น', style: "display: block" %>
      <%= datum.text_field :three_user_percent, class: 'form-control' %>
      <% user.errors.full_messages_for("user_datum.user_percent").each do |error_message| %>
        <div class="text-red">
          <%= error_message.sub("User datum user percent","") %>
        </div>
      <% end %>

      <%= datum.label :'วิ่ง/เปอร์เซ็น', style: "display: block" %>
      <%= datum.text_field :run_user_percent, class: 'form-control' %>
      <% user.errors.full_messages_for("user_datum.user_percent").each do |error_message| %>
        <div class="text-red">
          <%= error_message.sub("User datum user percent","") %>
        </div>
      <% end %>

      <%= datum.label :'Credit', style: "display: block" %>
      <%= datum.text_field :credit, class: 'form-control' %>
      <% user.errors.full_messages_for("user_datum.credit").each do |error_message| %>
        <div class="text-red">
          <%= error_message.sub("User datum user percent","") %>
        </div>
      <% end %>

      <div class="form-group">
        <%= datum.label 'อนุญาตให้สู้', style: "display: block" %>
        <%= datum.select :fightable, User::FIGHTABLE, {selected: user.user_datum.fightable || 0 }, class: 'form-control' %>
      </div>

    <% end %>


  <div>
    <%= form.submit 'บันทึก', class: 'btn btn-primary' %>
  </div>
<% end %>

app/views/users/edit.html.erb
<div class="container">
  <h1>แก้ไขผู้ใช้งาน</h1>

  <%= render "form", user: @user %>

  <br>

  <div class="pull-right">
    <%= link_to "กลับ", user_path(@user), class: 'btn btn-success' %>
  </div>
</div>

app/views/users/index.html.erb
<div class="container">
  <div class="pull-right">
    <%= link_to "เพิ่ม", new_user_path, class: 'btn btn-primary' %>
  </div> 
  <!-- Nav tabs -->
  <ul class="nav nav-tabs" role="tablist">
    <li role="presentation" class="active"><a href="#all" aria-controls="all" role="tab" data-toggle="tab">All</a></li>
    <li role="presentation"><a href="#members" aria-controls="members" role="tab" data-toggle="tab">Member</a></li>
    <li role="presentation"><a href="#agents" aria-controls="agents" role="tab" data-toggle="tab">Agents</a></li>
  </ul>

  <!-- Tab panes -->
  <div class="tab-content">
    <div role="tabpanel" class="tab-pane active" id="all">
      <table class="table">
        <thead>
          <tr>
            <th>ชื่อ</th>
            <th>username</th>
            <th>role</th>
            <th></th>
          </tr>
        </thead>
        <tbody>
          <% @users.each do |user| %>
          <tr>
            <td><%= user.name %></td>
            <td><%= user.username %></td>
            <td><%= user.role %></td>
            <td></td>
            <td class="manage">
              <%= link_to "ดู", user_path(user), class: 'btn btn-warning' %>
              <%= link_to "แก้ไข", edit_user_path(user), class: 'btn btn-success' %>
              <%= button_to "ลบ", user, method: :delete, class: 'btn btn-danger', data: { confirm: 'ยืนยันว่าจะลบ Member นี้' } %>
            </td>
          </tr>
          <% end %>
        </tbody>
      </table>
    </div>
    <div role="tabpanel" class="tab-pane" id="members">
      <table class="table">
        <thead>
          <tr>
            <th>ชื่อ</th>
            <th>username</th>
            <th>role</th>
            <th></th>
          </tr>
        </thead>
        <tbody>
          <% @members.each do |member| %>
          <tr>
            <td><%= member.name %></td>
            <td><%= member.username %></td>
            <td><%= member.role %></td>
            <td></td>
            <td class="manage">
              <%= link_to "ดู", user_path(member), class: 'btn btn-warning' %>
              <%= link_to "แก้ไข", edit_user_path(member), class: 'btn btn-success' %>
              <%= button_to "ลบ", member, method: :delete, class: 'btn btn-danger', data: { confirm: 'ยืนยันว่าจะลบ Member นี้' } %>
            </td>
          </tr>
          <% end %>
        </tbody>
      </table>
    </div>
    <div role="tabpanel" class="tab-pane" id="agents">
      <table class="table">
        <thead>
          <tr>
            <th>ชื่อ</th>
            <th>username</th>
            <th>role</th>
            <th></th>
          </tr>
        </thead>
        <tbody>
          <% @agents.each do |agent| %>
          <tr>
            <td><%= agent.name %></td>
            <td><%= agent.username %></td>
            <td><%= agent.role %></td>
            <td></td>
            <td class="manage">
              <%= link_to "ดู", user_path(agent), class: 'btn btn-warning' %>
              <%= link_to "แก้ไข", edit_user_path(agent), class: 'btn btn-success' %>
              <%= button_to "ลบ", agent, method: :delete, class: 'btn btn-danger', data: { confirm: 'ยืนยันว่าจะลบ Member นี้' } %>
            </td>
          </tr>
          <% end %>
        </tbody>
      </table>
    </div>
  </div>

</div>

app/views/users/new.html.erb
<div class="container">
  <h1>เพิ่มผู้ใช้งาน</h1>

  <%#= render "form", user: @user %>
  <% user =  @user %>

  <%= form_with(model: user, local: true) do |form| %>

  <div class="form-group">
    <%= form.label :role, style: "display: block" %>

    <% if current_user.admin?%>
      <%= form.select :role, User::ROLES, {}, class: 'form-control' %>
    <% else %>
      <%= form.select :role, User::MEMBERROLES, {}, class: 'form-control' %>
    <% end %>
  </div>

  <div class="form-group">
    <%= form.label :ชื่อ, style: "display: block" %>
    <%= form.text_field :name, class: 'form-control' %>
    <% user.errors.full_messages_for(:name).each do |error_message| %>
      <div class="text-red">
        <%= error_message.sub("Name","") %>
      </div>
    <% end %>

    <%= form.label :username, style: "display: block" %>
    <%= form.text_field :username, class: 'form-control' %>
    <% user.errors.full_messages_for(:username).each do |error_message| %>
      <div class="text-red">
        <%= error_message.sub("Username","") %>
      </div>
    <% end %>

    <%= form.label :email, style: "display: block" %>
    <%= form.text_field :email, class: 'form-control' %>
    <% user.errors.full_messages_for(:email).each do |error_message| %>
      <div class="text-red">
        <%= error_message.sub("email","") %>
      </div>
    <% end %>

    <%= form.fields_for :user_datum do |datum| %>
    
      <%= datum.label 'สองตัว/บาทละ', style: "display: block" %>
      <%= datum.text_field :percent, class: 'form-control' %>
      <% user.errors.full_messages_for("user_datum.percent").each do |error_message| %>
        <div class="text-red">
          <%= error_message.sub("User datum percent","") %>
        </div>
      <% end %>

      <%= datum.label 'สามตัวตรง/บาทละ', style: "display: block" %>
      <%= datum.text_field :three_percent, class: 'form-control' %>
      <% user.errors.full_messages_for("user_datum.three_percent").each do |error_message| %>
        <div class="text-red">
          <%= error_message.sub("User datum three percent","") %>
        </div>
      <% end %>

      <%= datum.label 'สามตัวโต๊ด/บาทละ', style: "display: block" %>
      <%= datum.text_field :three_reverse_percent, class: 'form-control' %>
      <% user.errors.full_messages_for("user_datum.three_reverse_percent").each do |error_message| %>
        <div class="text-red">
          <%= error_message.sub("User datum three reverse percent","") %>
        </div>
      <% end %>

      <%= datum.label 'วิ่งบน/บาทละ', style: "display: block" %>
      <%= datum.text_field :run_percent, class: 'form-control' %>
      <% user.errors.full_messages_for("user_datum.run_percent").each do |error_message| %>
        <div class="text-red">
          <%= error_message.sub("User datum run percent","") %>
        </div>
      <% end %>

      <%= datum.label 'วิ่งล่าง/บาทละ', style: "display: block" %>
      <%= datum.text_field :run_bottom_percent, class: 'form-control' %>
      <% user.errors.full_messages_for("user_datum.run_bottom_percent").each do |error_message| %>
        <div class="text-red">
          <%= error_message.sub("User datum run bottom percent","") %>
        </div>
      <% end %>

      <%= datum.label :'สองตัว/เปอร์เซ็น', style: "display: block" %>
      <%= datum.text_field :user_percent, class: 'form-control' %>
      <% user.errors.full_messages_for("user_datum.user_percent").each do |error_message| %>
        <div class="text-red">
          <%= error_message.sub("User datum user percent","") %>
        </div>
      <% end %>

      <%= datum.label :'สามตัว/เปอร์เซ็น', style: "display: block" %>
      <%= datum.text_field :three_user_percent, class: 'form-control' %>
      <% user.errors.full_messages_for("user_datum.user_percent").each do |error_message| %>
        <div class="text-red">
          <%= error_message.sub("User datum user percent","") %>
        </div>
      <% end %>

      <%= datum.label :'วิ่ง/เปอร์เซ็น', style: "display: block" %>
      <%= datum.text_field :run_user_percent, class: 'form-control' %>
      <% user.errors.full_messages_for("user_datum.user_percent").each do |error_message| %>
        <div class="text-red">
          <%= error_message.sub("User datum user percent","") %>
        </div>
      <% end %>

      <%= datum.label :'Credit', style: "display: block" %>
      <%= datum.text_field :credit, class: 'form-control' %>
      <% user.errors.full_messages_for("user_datum.credit").each do |error_message| %>
        <div class="text-red">
          <%= error_message.sub("User datum user percent","") %>
        </div>
      <% end %>

      <div class="form-group">
        <%= datum.label 'อนุญาตให้สู้', style: "display: block" %>
        <%= datum.select :fightable, User::FIGHTABLE, {selected: current_user.user_datum.fightable || 0 }, class: 'form-control' %>
      </div>

    <% end %>

    <%= form.label :รหัสผ่าน, style: "display: block" %>
    <%= form.password_field :password, class: 'form-control' %>
    <% user.errors.full_messages_for(:password).each do |error_message| %>
      <div class="text-red">
        <%= error_message.sub("password","") %>
      </div>
    <% end %>

    <%= form.label :ยืนยันรหัสผ่าน, style: "display: block" %>
    <%= form.password_field :password_confirmation, class: 'form-control' %>
    <% user.errors.full_messages_for(:password_confirmation).each do |error_message| %>
      <div class="text-red">
        <%= error_message.sub("password_confirmation","") %>
      </div>
    <% end %>


  <div>
    <%= form.submit 'บันทึก', class: 'btn btn-primary' %>
  </div>
<% end %>

  <br>

  <div class="pull-right">
    <%= link_to "กลับ", admins_path, class: 'btn btn-success' %>
  </div>
</div>

app/views/users/show.html.erb
<div class="container">
  <div class="row">
    <div class="col-sm-6 col-md-4 col-sm-offset-3 col-md-offset-4">
      <div class="thumbnail">
        <%= image_tag 'user.png', size: 64 %>
        <div class="caption">
          <h3><b>ชื่อ: </b><%= @user.name %></h3>
          <p><b>username: </b><%= @user.username %></p>
          <p><b>email:</b> <%= @user.email %></p>
          <p><b>ถูกเพิ่มโดย:</b> <%= User.find(@user.parent_id).name %></p>
          <p><b>สถานะ:</b> <%= @user.role %></p>
          <p><b>รายได้/สองตัว: </b> <%= @user.user_datum.try(:user_percent) %>%</p>
          <p><b>รายได้/สามตัว: </b> <%= @user.user_datum.try(:three_user_percent) %>%</p>
          <p><b>รายได้/วิ่ง: </b> <%= @user.user_datum.try(:run_user_percent) %>%</p>
          <p><b>สองตัว/บาทละ: </b> <%= @user.user_datum.try(:percent) %></p>
          <p><b>สามตัวตรง/บาทละ: </b> <%= @user.user_datum.try(:three_percent) %></p>
          <p><b>สามตัวโต๊ด/บาทละ: </b> <%= @user.user_datum.try(:three_reverse_percent) %></p>
          <p><b>วิ่ง/บาทละ: </b> <%= @user.user_datum.try(:run_percent) %></p>
          <p><b>สู้/สองตัว: </b> <%= @user.user_datum.try(:fight_percent) %>%</p>
          <p><b>จำกัดการสู้/สองตัว: </b> <%= @user.user_datum.try(:two_fight_limit) %> บาท</p>
          <p><b>สู้/สามตัว: </b> <%= @user.user_datum.try(:fight_three) %>%</p>
          <p><b>จำกัดการสู้/สามตัว: </b> <%= @user.user_datum.try(:three_fight_limit) %> บาท</p>
          <p><b>สู้/วิ่ง: </b> <%= @user.user_datum.try(:fight_run) %>%</p>
          <p><b>จำกัดการสู้/วิ่ง: </b> <%= @user.user_datum.try(:run_fight_limit) %> บาท</p>
          <p>
            <%= link_to "เปลี่ยนรหัสผ่าน", user_reset_passwords_path(@user), class: 'btn btn-warning' %>
            <%= link_to "กลับ", root_path, class: 'btn btn-success' %>
          </p>
        </div>
      </div>
    </div>
  </div>
</div>